Bug 125659

Summary: Subpixel layout: RenderInline is not centered when child RenderTextControl's innerTextRenderer needs bias centering.
Product: WebKit Reporter: zalan <zalan>
Component: Layout and RenderingAssignee: zalan <zalan>
Status: RESOLVED FIXED    
Severity: Normal CC: buildbot, commit-queue, hyatt, jonlee, kling, rniwa, simon.fraser, webkit-bug-importer
Priority: P2 Keywords: InRadar
Version: 528+ (Nightly build)   
Hardware: Unspecified   
OS: Unspecified   
Bug Depends on:    
Bug Blocks: 126283    
Attachments:
Description Flags
test case
none
Patch
none
Archive of layout-test-results from webkit-ews-11 for mac-mountainlion-wk2
none
Archive of layout-test-results from webkit-ews-04 for mac-mountainlion
none
Archive of layout-test-results from webkit-ews-16 for mac-mountainlion-wk2
none
Patch none

Description zalan 2013-12-12 14:55:03 PST
Created attachment 219123 [details]
test case

with subpixel layout on, we calculate the innerTextRenderer's top logical position wrong and we push the parent element to upwards of one pixel (in default (top-to-bottom) mode)
Comment 1 Jon Lee 2013-12-12 15:23:56 PST
<rdar://problem/15651368
>
Comment 2 zalan 2013-12-12 19:49:02 PST
Placing the innerTextRenderer in RenderTextControlSingleLine::layout() needs to be subpixel compliant. 
innerTextRenderer->setLogicalTop(innerTextRenderer->logicalTop() - (logicalHeightDiff / 2 + layoutMod(logicalHeightDiff, 2)));
Comment 3 Jon Lee 2014-01-14 00:34:03 PST
<rdar://problem/15651368>
Comment 4 zalan 2014-01-25 10:30:25 PST
Created attachment 222216 [details]
Patch
Comment 5 Andreas Kling 2014-01-25 11:17:05 PST
Comment on attachment 222216 [details]
Patch

View in context: https://bugs.webkit.org/attachment.cgi?id=222216&action=review

r=me

> Source/WebCore/rendering/RenderTextControlSingleLine.h:46
> +    void centerRenderer(RenderBox& renderer) const;

Maybe we could call this centerInnerRenderer() to make it clear that it centers it within itself.
Also we can omit the argument name here.
Comment 6 Andreas Kling 2014-01-25 11:17:56 PST
mac-wk2 says:

Unexpected flakiness: text-only failures (1)
  editing/caret/caret-color.html [ Failure Pass ]

Regressions: Unexpected text-only failures (1)
  fast/forms/search-vertical-alignment.html [ Failure ]
Comment 7 Build Bot 2014-01-25 11:44:16 PST
Comment on attachment 222216 [details]
Patch

Attachment 222216 [details] did not pass mac-wk2-ews (mac-wk2):
Output: http://webkit-queues.appspot.com/results/4855899218771968

New failing tests:
fast/forms/search-vertical-alignment.html
Comment 8 Build Bot 2014-01-25 11:44:18 PST
Created attachment 222223 [details]
Archive of layout-test-results from webkit-ews-11 for mac-mountainlion-wk2

The attached test failures were seen while running run-webkit-tests on the mac-wk2-ews.
Bot: webkit-ews-11  Port: mac-mountainlion-wk2  Platform: Mac OS X 10.8.5
Comment 9 Build Bot 2014-01-25 12:17:13 PST
Comment on attachment 222216 [details]
Patch

Attachment 222216 [details] did not pass mac-ews (mac):
Output: http://webkit-queues.appspot.com/results/5957994806247424

New failing tests:
fast/forms/search-vertical-alignment.html
Comment 10 Build Bot 2014-01-25 12:17:17 PST
Created attachment 222225 [details]
Archive of layout-test-results from webkit-ews-04 for mac-mountainlion

The attached test failures were seen while running run-webkit-tests on the mac-ews.
Bot: webkit-ews-04  Port: mac-mountainlion  Platform: Mac OS X 10.8.5
Comment 11 Build Bot 2014-01-25 12:53:06 PST
Comment on attachment 222216 [details]
Patch

Attachment 222216 [details] did not pass mac-wk2-ews (mac-wk2):
Output: http://webkit-queues.appspot.com/results/4659595926568960

New failing tests:
fast/forms/search-vertical-alignment.html
Comment 12 Build Bot 2014-01-25 12:53:09 PST
Created attachment 222227 [details]
Archive of layout-test-results from webkit-ews-16 for mac-mountainlion-wk2

The attached test failures were seen while running run-webkit-tests on the mac-wk2-ews.
Bot: webkit-ews-16  Port: mac-mountainlion-wk2  Platform: Mac OS X 10.8.5
Comment 13 zalan 2014-01-25 13:12:01 PST
Created attachment 222229 [details]
Patch
Comment 14 zalan 2014-01-25 13:12:24 PST
Comment on attachment 222229 [details]
Patch

EWS testing.
Comment 15 WebKit Commit Bot 2014-01-25 17:22:56 PST
Comment on attachment 222229 [details]
Patch

Clearing flags on attachment: 222229

Committed r162791: <http://trac.webkit.org/changeset/162791>
Comment 16 WebKit Commit Bot 2014-01-25 17:23:00 PST
All reviewed patches have been landed.  Closing bug.